package repository

import (
	"actatempus_backend/internal/domain/entities"
	"context"

	E "github.com/IBM/fp-go/either"
)

// UserRepository defines the operations for interacting with user data.

type UserRepository interface {
	Create(ctx context.Context) func(user entities.UserCreate) E.Either[error, entities.User]
	FindByID(ctx context.Context) func(id string) E.Either[error, entities.User]
	FindByEmail(ctx context.Context) func(email string) E.Either[error, entities.User]
	Update(ctx context.Context) func(user entities.UserUpdate) E.Either[error, entities.User]
	Delete(ctx context.Context) func(id string) E.Either[error, entities.User]
	FindAll(ctx context.Context) E.Either[error, []entities.User] // Keine zusätzlichen Argumente nötig
}
